From 5a65435dc33dcba889237c9381b519c8831fe825 Mon Sep 17 00:00:00 2001
From: 3np <3np@example.com>
Date: Mon, 1 Aug 2022 13:31:57 +0900
Subject: [PATCH 15/21] web: fix timezone mishandling in Retry-Header parsing

---
 mopidy_spotify/web.py | 11 ++++----
 tests/test_web.py     | 66 +++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 72 insertions(+), 5 deletions(-)

diff --git a/mopidy_spotify/web.py b/mopidy_spotify/web.py
index 5f3bb4b4..4499e19b 100644
--- a/mopidy_spotify/web.py
+++ b/mopidy_spotify/web.py
@@ -1,5 +1,4 @@
 import copy
-import email
 import logging
 import os
 import re
@@ -9,6 +8,7 @@
 from datetime import datetime
 from enum import Enum, unique
 from typing import Optional
+from email.utils import parsedate_to_datetime
 
 import requests
 
@@ -258,11 +258,12 @@ def _parse_retry_after(self, response):
         elif re.match(r"^\s*[0-9]+\s*$", value):
             seconds = int(value)
         else:
-            date_tuple = email.utils.parsedate(value)
-            if date_tuple is None:
+            now = datetime.utcnow()
+            try:
+                date_tuple = parsedate_to_datetime(value)
+                seconds = (date_tuple - now).seconds
+            except ValueError:
                 seconds = 0
-            else:
-                seconds = time.mktime(date_tuple) - time.time()
         return max(0, seconds)
 
 
diff --git a/tests/test_web.py b/tests/test_web.py
index 90f29204..5ec6a79d 100644
--- a/tests/test_web.py
+++ b/tests/test_web.py
@@ -1,10 +1,12 @@
 import urllib
 from unittest import mock
 
+from time import time
 import pytest
 import requests
 import responses
 from responses import matchers
+from email.utils import formatdate
 
 import mopidy_spotify
 from mopidy_spotify import web
@@ -892,6 +894,70 @@ def test_get_one_increased_expiry(self, mock_time, spotify_client):
 
         assert 1000 + spotify_client.DEFAULT_EXTRA_EXPIRY == result._expires
 
+    @responses.activate
+    def test_get_one_retry_header_invalid(self, spotify_client, caplog):
+        responses.add(
+            responses.GET,
+            url("foo"),
+            status=429,
+            adding_headers={"Retry-After": " herpderp "},
+        )
+        responses.add(
+            responses.GET, url("foo"), json={"error": "bar"}, status=403
+        )
+
+        result = spotify_client.get_one("foo")
+
+        assert result == {}
+        assert (
+            "Retrying https://api.spotify.com/v1/foo in 0.500 seconds."
+            in caplog.text
+        )
+        assert "Spotify Web API request failed: bar" in caplog.text
+
+    @responses.activate
+    def test_get_one_retry_header_date(self, spotify_client, caplog):
+        t = time() + 2
+        responses.add(
+            responses.GET,
+            url("foo"),
+            status=429,
+            adding_headers={"Retry-After": formatdate(t)},
+        )
+        responses.add(
+            responses.GET, url("foo"), json={"error": "bar"}, status=403
+        )
+
+        result = spotify_client.get_one("foo")
+
+        assert result == {}
+        assert (
+            "Retrying https://api.spotify.com/v1/foo in 1.000 seconds."
+            in caplog.text
+        )
+        assert "Spotify Web API request failed: bar" in caplog.text
+
+    @responses.activate
+    def test_get_one_retry_header_seconds(self, spotify_client, caplog):
+        responses.add(
+            responses.GET,
+            url("foo"),
+            status=429,
+            adding_headers={"Retry-After": " 1 "},
+        )
+        responses.add(
+            responses.GET, url("foo"), json={"error": "bar"}, status=403
+        )
+
+        result = spotify_client.get_one("foo")
+
+        assert result == {}
+        assert (
+            "Retrying https://api.spotify.com/v1/foo in 1.000 seconds."
+            in caplog.text
+        )
+        assert "Spotify Web API request failed: bar" in caplog.text
+
     @responses.activate
     def test_get_all(self, spotify_client):
         responses.add(

